unit UntDivizorComun;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmDivizorComun = class(TForm)
    PNMDC: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    txtMDC1: TEdit;
    txtMDC2: TEdit;
    BtnOkMDC: TButton;
    pnResult: TPanel;
    Pnmmc: TPanel;
    btnmmc: TButton;
    txtmmc2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    txtmmc1: TEdit;
    Label5: TLabel;
    procedure BtnOkMDCClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnmmcClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDivizorComun: TfrmDivizorComun;

implementation

{$R *.dfm}
//funo para maximo divizor comum

function mdc(x, y: integer): integer;
begin
  if (x = y) then
    result := x
  else if (y > x) then
    result := mdc(x, y - x)

  else if (x > y) then
    result := mdc(x - y, y);
end;

//funcao pra minimo multiplo comun

function MMC(Valores: array of integer): extended;
  procedure Computar(r, i: integer; var fim: integer; var computer: Boolean);
  begin
    if (valores[r] mod i) = 0 then
    begin
      Computer := true;
      Valores[r] := Valores[r] div i
    end;
    fim := fim * valores[r];
  end;
var
  r, i, Fim: integer;
  computer: boolean;
begin
  i := 2;
  result := 1;
  repeat
    begin
      Fim := 1;
      computer := False;
      for r := 0 to high(valores) do
        if Valores[r] > 1 then
          computar(r, i, fim, computer);
      if computer then
        result := result * i
      else
        i := i + 1;
    end;
  until
    (Fim = 1);
end;

procedure TfrmDivizorComun.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

procedure TfrmDivizorComun.BtnOkMDCClick(Sender: TObject);
var
  mmdc: real;
begin
  txtMDC1.SetFocus;
  if StrToInt(txtMDC1.Text) > 0 then begin
    mmdc := mdc(StrToInt(txtMDC1.Text), StrToInt(txtMDC2.Text));
    pnResult.Caption := FloatToStr(mmdc);
  end else
    ShowMessage('O valor no pode ser 0 (Zero) ou nulo');

end;

procedure TfrmDivizorComun.btnmmcClick(Sender: TObject);
var
  result_mmc: extended;
  a, b: integer;
begin
  txtmmc1.SetFocus;
  if StrToInt(txtmmc1.Text) > 0 then begin
    a := StrToInt(txtmmc1.Text);
    b := StrToInt(txtmmc2.Text);

    result_mmc := MMC([a, b]);
    Pnmmc.Caption := FloatToStr(result_mmc);
  end else
    ShowMessage('O valor no pode ser 0 (Zero) ou nulo');
end;

end.

