unit UntFatorial;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFrmFatorial = class(TForm)
    GroupBox1: TGroupBox;
    EditN: TEdit;
    Label37: TLabel;
    Label1: TLabel;
    lblResult: TLabel;
    ButtonExit: TButton;
    ButtonClear: TButton;
    ButtonRecursao: TButton;
    ButtonDireto: TButton;
    procedure ButtonDiretoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonRecursaoClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmFatorial: TFrmFatorial;

implementation

{$R *.dfm}

function FatorialFunc(N: integer): integer;
var i, Fat: integer;
begin
  Fat := 1;
  for i := 1 to N do
    begin
      Fat := Fat * i;
    end;
  FatorialFunc := Fat;
end;


procedure FatorialProc(N: integer; var Fat: integer);
var i: integer;
begin
  Fat := 1;
  for i := 1 to N do
    begin
      Fat := Fat * i;
    end;
end;

function FatorialRec(N: integer): integer;
begin
  if n > 1 then
    FatorialRec := FatorialRec(N - 1) * N
  else
    FatorialRec := 1;
end;

procedure TFrmFatorial.ButtonDiretoClick(Sender: TObject);
var N, Fat: integer;
begin
  // Entrada De Dados
  N := StrToInt(EditN.Text);
  // Computao De Dados
  Fat := FatorialFunc(N);
  // Sada De Dados
  lblResult.Caption := IntToStr(Fat);
  EditN.SetFocus;
end;

procedure TFrmFatorial.FormShow(Sender: TObject);
begin
  EditN.SetFocus;
end;

procedure TFrmFatorial.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
    begin
      key := #0;
      perform(WM_NEXTDLGCTL, 0, 0);
    end;
  //fecha form
  if Key = #27 then
    close;
end;

procedure TFrmFatorial.ButtonRecursaoClick(Sender: TObject);
var N, Fat: integer;
begin
  // Entrada De Dados
  N := StrToInt(EditN.Text);
  // Computao De Dados
  Fat := FatorialRec(N);
  // Sada de Dados
  lblResult.Caption := IntToStr(Fat);
end;

procedure TFrmFatorial.ButtonClearClick(Sender: TObject);
begin
  sleep(100);
  EditN.clear;
  lblResult.Caption := '';
  EditN.SetFocus;
end;

procedure TFrmFatorial.ButtonExitClick(Sender: TObject);
begin
  FrmFatorial.Close;
end;

end.

