unit UntRaiz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Math, StdCtrls, ExtCtrls;

type
  TfrmRaiz = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    btnCalcular: TButton;
    Label2: TLabel;
    pnresultado: TPanel;
    txtRaizQuadrada: TEdit;
    txtRaiz: TEdit;
    lblNegativo: TLabel;
    procedure btnCalcularClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRaiz: TfrmRaiz;

implementation

{$R *.dfm}

function Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;

procedure TfrmRaiz.btnCalcularClick(Sender: TObject);
var
  raiz: real;
begin
  if (StrToInt(txtRaiz.Text) > 0) then begin
    raiz := Arredondar(power(StrToFloat(txtRaiz.Text), (1 / StrToFloat(txtRaizQuadrada.Text))), 6);
    pnresultado.Caption := FloatToStr(raiz);
    lblNegativo.Caption := '';
  end else begin
    lblNegativo.Caption := 'No existe Raiz de nmero negativo';
    pnresultado.Caption := '';
  end;
  
  txtRaiz.SetFocus;

end;

procedure TfrmRaiz.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

end.

