unit UntRealacaodeEuler;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmrealacaodeEuler = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    txtF: TEdit;
    txtV: TEdit;
    txtA: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    btnCalcular: TButton;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    pnRF: TPanel;
    pnRV: TPanel;
    pnRa: TPanel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnCalcularClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmrealacaodeEuler: TfrmrealacaodeEuler;

implementation

{$R *.dfm}

function Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;

procedure TfrmrealacaodeEuler.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

procedure TfrmrealacaodeEuler.btnCalcularClick(Sender: TObject);
var
  arestas, faces, vertices: real;
begin
  if (txtF.Text = '') or (txtF.Text = '0') then begin
    faces := Arredondar(((2 + StrToFloat(txtA.Text)) - StrToFloat(txtV.Text)), 4);

    Label12.Visible := true;
    Label13.Visible := false;
    Label14.Visible := false;

    pnRF.Visible := true;
    pnRa.Visible := false;
    pnRV.Visible := false;

    pnRF.Caption := FloatToStr(faces);
  end;

  if (txtV.Text = '') or (txtV.Text = '0') then begin
    vertices := Arredondar(((2 + StrToFloat(txtA.Text)) - StrToFloat(txtF.Text)), 4);

    Label12.Visible := false;
    Label13.Visible := true;
    Label14.Visible := false;

    pnRF.Visible := false;
    pnRa.Visible := false;
    pnRV.Visible := true;
    
    pnRv.Caption := FloatToStr(vertices);
  end;

    if (txtA.Text = '') or (txtA.Text = '0') then begin
    arestas := Arredondar(((-2 + StrToFloat(txtV.Text)) + StrToFloat(txtF.Text)), 4);

    Label12.Visible := false;
    Label13.Visible := false;
    Label14.Visible := true;

    pnRF.Visible := false;
    pnRa.Visible := true;
    pnRV.Visible := false;
    
    pnRa.Caption := FloatToStr(arestas);
  end;
  txtF.SetFocus;
end;

end.

