unit UntRegradetres;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmRegradetres = class(TForm)
    txtValorx: TEdit;
    txtValor2: TEdit;
    txtValor1: TEdit;
    txtValor3: TEdit;
    btnCalcular: TButton;
    Panel1: TPanel;
    lblResultado: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure btnCalcularClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRegradetres: TfrmRegradetres;

implementation

uses UntArea, Math;

{$R *.dfm}

function Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;

procedure TfrmRegradetres.btnCalcularClick(Sender: TObject);
var
  regra: real;
begin
regra:=Arredondar((StrToFloat(txtValor2.Text)*StrToFloat(txtValor1.Text))/ StrToFloat(txtValor3.Text),2);
 lblResultado.Caption:= 'X = '+FloatToStr(regra);
end;

procedure TfrmRegradetres.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

end.

