unit UntArea;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Math;

type
  TfrmCalculaArea = class(TForm)
    GbOperacoes: TGroupBox;
    pnTriangulo: TPanel;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    txts: TEdit;
    txth: TEdit;
    txta: TEdit;
    lblcalcula: TLabel;
    btnCalcular: TButton;
    Label4: TLabel;
    lblArea: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    btnTriangulo: TSpeedButton;
    btnParalelogramo: TSpeedButton;
    btnQuadrado: TSpeedButton;
    btnRetangulo: TSpeedButton;
    btnLosango: TSpeedButton;
    btnTrapezio: TSpeedButton;
    btnTrianguloEquilatero: TSpeedButton;
    lblh: TLabel;
    lbla: TLabel;
    pnQuadrado: TPanel;
    Image2: TImage;
    Label5: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    lblAreaQ: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lblaQ: TLabel;
    txtsQ: TEdit;
    txtaQ: TEdit;
    btnCalcularQ: TButton;
    pnLosango: TPanel;
    Image3: TImage;
    Label8: TLabel;
    Label12: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    lblSL: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    lbldF: TLabel;
    txtsL: TEdit;
    txtdL: TEdit;
    blncalcularL: TButton;
    txtddL: TEdit;
    Label21: TLabel;
    lblddl: TLabel;
    pnTrapezio: TPanel;
    Image4: TImage;
    Label17: TLabel;
    Label20: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    lblTrapezioS: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    lblTrapezioB: TLabel;
    Label28: TLabel;
    lblTrapezioh: TLabel;
    txtTrapezioS: TEdit;
    txttrapezioB: TEdit;
    btnCalcularTrapezio: TButton;
    txtTrapezioh: TEdit;
    txtTrapeziobb: TEdit;
    Label30: TLabel;
    lblTrapeziobb: TLabel;
    pnParalelogramo: TPanel;
    Image5: TImage;
    Label24: TLabel;
    Label29: TLabel;
    Label31: TLabel;
    lblParalelogramoS: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label36: TLabel;
    lblParalelogramoh: TLabel;
    Label38: TLabel;
    lblParalelogramoa: TLabel;
    TxtParalelogramoS: TEdit;
    btnParalelo: TButton;
    TxtParalelogramoh: TEdit;
    TxtParalelogramoa: TEdit;
    pnRetangulo: TPanel;
    Image6: TImage;
    Label27: TLabel;
    Label32: TLabel;
    Label35: TLabel;
    LblRetangulos: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    LblRetangulob: TLabel;
    Label43: TLabel;
    LblRetanguloa: TLabel;
    TxtRetangulos: TEdit;
    btnRetan: TButton;
    TxtRetangulob: TEdit;
    TxtRetanguloa: TEdit;
    pnTriEquilatero: TPanel;
    Image7: TImage;
    Label37: TLabel;
    Label42: TLabel;
    Label44: TLabel;
    lblTriEquilateros: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    lblTriEquilatero: TLabel;
    lblTriEquilaterol: TLabel;
    TxtTriEquilateroS: TEdit;
    btnlblTriEquilatero: TButton;
    TxtTriEquilaterol: TEdit;
    btnSair: TSpeedButton;
    procedure btnTrianguloClick(Sender: TObject);
    procedure btnCalcularClick(Sender: TObject);
    procedure btnQuadradoClick(Sender: TObject);
    procedure btnCalcularQClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnLosangoClick(Sender: TObject);
    procedure blncalcularLClick(Sender: TObject);
    procedure btnTrapezioClick(Sender: TObject);
    procedure btnCalcularTrapezioClick(Sender: TObject);
    procedure btnParalelogramoClick(Sender: TObject);
    procedure btnParaleloClick(Sender: TObject);
    procedure btnRetanguloClick(Sender: TObject);
    procedure btnRetanClick(Sender: TObject);
    procedure btnTrianguloEquilateroClick(Sender: TObject);
    procedure btnlblTriEquilateroClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);

    function Arredondar(Valor: Double; Dec: Integer): Double;
  private
    { Private declarations }
  public
    { Public declarations }
    //function Arredondar(Valor: Double; Dec: Integer): Double;
  end;

var
  frmCalculaArea: TfrmCalculaArea;
  area, altura, base, baseb: real;



implementation

uses UntBhaskara, UntPitagoras, untPrincipal;

{$R *.dfm}

function TfrmCalculaArea.Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;


procedure TfrmCalculaArea.btnTrianguloClick(Sender: TObject);
begin
  pnTriangulo.Visible := true;
  pnQuadrado.Visible := false;
  pnLosango.Visible := false;
  pnTrapezio.Visible := false;
  pnParalelogramo.Visible := false;
  pnRetangulo.Visible := false;
  pnTriEquilatero.Visible := false;
  txts.SetFocus;
end;

procedure TfrmCalculaArea.btnCalcularClick(Sender: TObject);
begin

  if (txth.Text = '') or (txth.Text = '0') then begin
    lbla.Caption := '';
    lblArea.Caption := 'S = ' + txts.Text + ' m';
    altura := Arredondar(((StrToFloat(txts.Text) * 2) / StrToFloat(txta.Text)), 2);
    lblh.Caption := '> h = ' + FloatToStr(altura);
  end;

  if (txta.Text = '') or (txta.Text = '0') then begin
    lblh.Caption := '';
    lblArea.Caption := 'S = ' + txts.Text + ' m';
    base := Arredondar((2 * (StrToFloat(txts.Text)) / StrToFloat(txth.Text)), 2);
    lbla.Caption := '> a = ' + FloatToStr(base);
  end;

  if (txts.Text = '') or (txts.Text = '0') then begin
    lblh.Caption := '';
    lbla.Caption := '';
    lblArea.Caption := ' ';
    area := Arredondar(((StrToFloat(txta.Text)) * StrToFloat(txth.Text) / 2), 2);
    lblArea.Caption := '> S = ' + FloatToStr(area) + ' m';
  end;

  txts.SetFocus;
end;

procedure TfrmCalculaArea.btnQuadradoClick(Sender: TObject);
begin
  pnQuadrado.Visible := true;
  pnTriangulo.Visible := false;
  pnLosango.Visible := false;
  pnTrapezio.Visible := false;
  pnParalelogramo.Visible := false;
  pnRetangulo.Visible := false;
  pnTriEquilatero.Visible := false;
  txtsQ.SetFocus;

end;

procedure TfrmCalculaArea.btnCalcularQClick(Sender: TObject);
begin
  if (txtsQ.Text = '') or (txtsQ.Text = '0') then begin
    area := Arredondar(power(StrToFloat(txtaQ.Text), 2), 2);
    lblAreaQ.Caption := 'S = ' + FloatToStr(area) + ' m';
    lblaQ.Caption := '';
  end;

  if (txtaQ.Text = '') or (txtaQ.Text = '0') then begin
    base := Arredondar(Sqrt(StrToFloat(txtsQ.Text)), 2);
    lblaQ.Caption := '> a = ' + FloatToStr(base);
    lblAreaQ.Caption := 'S = ' + txtsQ.Text;
  end;

  txtsQ.SetFocus;
end;

procedure TfrmCalculaArea.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

procedure TfrmCalculaArea.btnLosangoClick(Sender: TObject);
begin
  pnQuadrado.Visible := false;
  pnTriangulo.Visible := false;
  pnLosango.Visible := true;
  pnTrapezio.Visible := false;
  pnParalelogramo.Visible := false;
  pnRetangulo.Visible := false;
  pnTriEquilatero.Visible := false;
  txtsL.SetFocus;
end;

procedure TfrmCalculaArea.blncalcularLClick(Sender: TObject);
begin
  if (txtsL.Text = '') or (txtsL.Text = '0') then begin
    area := Arredondar(((StrToFloat(txtdL.Text) * StrToFloat(txtddL.Text)) / 2), 2);
    lblSL.Caption := 'S = ' + FloatToStr(area) + ' m';
    lbldF.Caption := '';
    lblddl.Caption := '';
  end;

  if (txtdL.Text = '') or (txtdL.Text = '0') then begin
    base := Arredondar(((StrToFloat(txtsL.Text) * 2) / StrToFloat(txtddL.Text)), 2);
    lbldF.Caption := '> D =' + FloatToStr(base);
    lblSL.Caption := 'S = ' + txtsL.Text + ' m';
    lblddl.Caption := '';
  end;

  if (txtddL.Text = '') or (txtddL.Text = '0') then begin
    altura := Arredondar(((StrToFloat(txtsL.Text) * 2) / StrToFloat(txtdL.Text)), 2);
    lblddl.Caption := '> d =' + FloatToStr(altura);
    lblSL.Caption := 'S = ' + txtsL.Text + ' m';
    lbldF.Caption := '';
  end;

  txtsL.SetFocus;
end;

procedure TfrmCalculaArea.btnTrapezioClick(Sender: TObject);
begin
  pnQuadrado.Visible := false;
  pnTriangulo.Visible := false;
  pnLosango.Visible := false;
  pnTrapezio.Visible := true;
  pnParalelogramo.Visible := false;
  pnRetangulo.Visible := false;
  pnTriEquilatero.Visible := false;
  txtTrapezioS.SetFocus;

end;

procedure TfrmCalculaArea.btnCalcularTrapezioClick(Sender: TObject);
begin
  if (txtTrapezioS.Text = '') or (txtTrapezioS.Text = '0') then begin
    area := Arredondar((((StrToFloat(txttrapezioB.Text) + StrToFloat(txtTrapeziobb.Text)) * StrToFloat(txtTrapezioh.Text)) / 2), 2);
    lblTrapezioS.Caption := 'S = ' + FloatToStr(area) + ' m';
    lblTrapezioB.Caption := '';
    lblTrapezioh.Caption := '';
    lblTrapeziobb.Caption := '';
  end;

  if (txttrapezioB.Text = '') or (txtTrapezioB.Text = '0') then begin
    base := Arredondar((((2 * (StrToFloat(txtTrapezioS.Text)) / StrToFloat(txtTrapezioh.Text)) - StrToFloat(txtTrapeziobb.Text))), 2);
    lblTrapezioB.Caption := '> B = ' + FloatToStr(base);
    lblTrapezioS.Caption := 'S = ' + txtTrapezioS.Text + ' m';
    lblTrapezioh.Caption := '';
    lblTrapeziobb.Caption := '';
  end;

  if (txtTrapezioh.Text = '') or (txtTrapezioh.Text = '0') then begin
    baseb := Arredondar((2 * StrToFloat(txtTrapezioS.Text)) / (StrToFloat(txtTrapeziobb.Text) + StrToFloat(txttrapezioB.Text)), 2);
    lblTrapezioh.Caption := '> h = ' + FloatToStr(baseb);
    lblTrapezioS.Caption := 'S = ' + txtTrapezioS.Text + ' m';
    lblTrapezioB.Caption := '';
    lblTrapeziobb.Caption := '';
  end;

  if (txtTrapeziobb.Text = '') or (txtTrapeziobb.Text = '0') then begin
    altura := Arredondar(((2 * StrToFloat(txtTrapezioS.Text)) / StrToFloat(txtTrapezioh.Text)) - StrToFloat(txttrapezioB.Text), 2);
    lblTrapeziobb.Caption := '> b = ' + FloatToStr(altura);
    lblTrapezioS.Caption := 'S = ' + txtTrapezioS.Text + ' m';
    lblTrapezioB.Caption := '';
    lblTrapezioh.Caption := '';
  end;

  txtTrapezioS.SetFocus;
end;

procedure TfrmCalculaArea.btnParalelogramoClick(Sender: TObject);
begin
  pnQuadrado.Visible := false;
  pnTriangulo.Visible := false;
  pnLosango.Visible := false;
  pnTrapezio.Visible := false;
  pnParalelogramo.Visible := true;
  pnRetangulo.Visible := false;
  pnTriEquilatero.Visible := false;
  TxtParalelogramoS.SetFocus;

end;

procedure TfrmCalculaArea.btnParaleloClick(Sender: TObject);
begin
  if (TxtParalelogramoS.Text = '') or (TxtParalelogramoS.Text = '0') then begin
    area := Arredondar((StrToFloat(TxtParalelogramoa.Text) * StrToFloat(TxtParalelogramoh.Text)), 2);
    lblParalelogramoS.Caption := 'S = ' + FloatToStr(area) + ' m';
    lblParalelogramoh.Caption := '';
    lblParalelogramoa.Caption := '';
  end;

  if (TxtParalelogramoh.Text = '') or (TxtParalelogramoh.Text = '0') then begin
    altura := Arredondar((StrToFloat(TxtParalelogramoS.Text) / StrToFloat(TxtParalelogramoa.Text)), 2);
    lblParalelogramoS.Caption := 'S = ' + TxtParalelogramoS.Text + ' m';
    lblParalelogramoh.Caption := '> h = ' + FloatToStr(altura);
    lblParalelogramoa.Caption := '';
  end;

  if (TxtParalelogramoa.Text = '') or (TxtParalelogramoa.Text = '0') then begin
    base := Arredondar((StrToFloat(TxtParalelogramoS.Text) / StrToFloat(TxtParalelogramoh.Text)), 2);
    lblParalelogramoS.Caption := 'S = ' + TxtParalelogramoS.Text + ' m';
    lblParalelogramoa.Caption := '> a = ' + FloatToStr(base);
    lblParalelogramoh.Caption := '';
  end;

  TxtParalelogramoS.SetFocus;
end;

procedure TfrmCalculaArea.btnRetanguloClick(Sender: TObject);
begin
  pnQuadrado.Visible := false;
  pnTriangulo.Visible := false;
  pnLosango.Visible := false;
  pnTrapezio.Visible := false;
  pnParalelogramo.Visible := false;
  pnRetangulo.Visible := true;
  pnTriEquilatero.Visible := false;
  TxtRetangulos.SetFocus;
end;

procedure TfrmCalculaArea.btnRetanClick(Sender: TObject);
begin
  if (TxtRetangulos.Text = '') or (TxtRetangulos.Text = '0') then begin
    area := Arredondar((StrToFloat(TxtRetanguloa.Text) * StrToFloat(TxtRetangulob.Text)), 2);
    LblRetangulos.Caption := 'S = ' + FloatToStr(area) + ' m';
    LblRetanguloa.Caption := '';
    LblRetangulob.Caption := '';
  end;

  if (TxtRetangulob.Text = '') or (TxtRetangulob.Text = '0') then begin
    base := Arredondar((StrToFloat(TxtRetangulos.Text) / StrToFloat(TxtRetanguloa.Text)), 2);
    LblRetangulos.Caption := 'S = ' + TxtRetangulob.Text + ' m';
    LblRetanguloa.Caption := '';
    LblRetangulob.Caption := '> b =' + FloatToStr(base);
  end;

  if (TxtRetanguloa.Text = '') or (TxtRetanguloa.Text = '0') then begin
    altura := Arredondar((StrToFloat(TxtRetangulos.Text) / StrToFloat(TxtRetangulob.Text)), 2);
    LblRetangulos.Caption := 'S = ' + TxtRetangulob.Text + ' m';
    LblRetanguloa.Caption := '> a =' + FloatToStr(altura);
    LblRetangulob.Caption := '';
  end;

  TxtRetangulos.SetFocus;
end;

procedure TfrmCalculaArea.btnTrianguloEquilateroClick(Sender: TObject);
begin
  pnQuadrado.Visible := false;
  pnTriangulo.Visible := false;
  pnLosango.Visible := false;
  pnTrapezio.Visible := False;
  pnParalelogramo.Visible := False;
  pnRetangulo.Visible := False;
  pnTriEquilatero.Visible := True;

  TxtTriEquilateroS.SetFocus;
end;

procedure TfrmCalculaArea.btnlblTriEquilateroClick(Sender: TObject);
begin
  if (TxtTriEquilateroS.Text = '') or (TxtTriEquilateroS.Text = '0') then begin
    area := Arredondar(((power(StrToFloat(TxtTriEquilaterol.text), 2) * Sqrt(3)) / 4), 2);
    lblTriEquilateros.Caption := 'S = ' + FloatToStr(area) + ' m';
    lblTriEquilaterol.Caption := '';
  end;

   if (TxtTriEquilaterol.Text = '') or (TxtTriEquilaterol.Text = '0') then begin
    altura := Arredondar(Sqrt((4* StrToFloat(TxtTriEquilateroS.Text))/Sqrt(3)),2);
    //Arredondar(((power(StrToFloat(TxtTriEquilaterol.text), 2) * Sqrt(3)) / 4), 6);
    lblTriEquilateros.Caption := 'S = ' + TxtTriEquilateros.Text + ' m';
    lblTriEquilaterol.Caption := '> l = ' +  FloatToStr(altura);
  end;

  TxtTriEquilateroS.SetFocus;
end;

procedure TfrmCalculaArea.btnSairClick(Sender: TObject);
begin
frmCalculaArea.Close;
end;


end.

