unit UntBhaskara;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Math;

type
  TfrmBhaskara = class(TForm)
    lblBhaskara: TLabel;
    lblFormula: TLabel;
    STGBhaskara: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txta: TEdit;
    txtb: TEdit;
    txtc: TEdit;
    btnCalcular: TButton;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    lblRaiznegativa: TLabel;
    LblNaocalcula: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lblX1: TLabel;
    lblX2: TLabel;
    lblraiz: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnCalcularClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBhaskara: TfrmBhaskara;

implementation

uses UntArea, UntPitagoras, untPrincipal;

{$R *.dfm}

procedure TfrmBhaskara.FormCreate(Sender: TObject);
begin
  //Retita o modo de edio do stringrid
  STGBhaskara.Options := STGBhaskara.Options - [goEditing];
  //linha 0
  STGBhaskara.Cells[0, 0] := '     a';
  STGBhaskara.Cells[2, 0] := '     b';
  STGBhaskara.Cells[4, 0] := '     c';
  //linha 1
  STGBhaskara.Cells[1, 1] := '   x +';
  STGBhaskara.Cells[3, 1] := '   x +';
  STGBhaskara.Cells[5, 1] := '   = 0';
end;

procedure TfrmBhaskara.btnCalcularClick(Sender: TObject);
var
  delta, x1, x2: real;
begin
  STGBhaskara.Cells[0, 1] := '     ' + txta.Text;
  STGBhaskara.Cells[2, 1] := '     ' + txtb.Text;
  STGBhaskara.Cells[4, 1] := '     ' + txtc.Text;

  //Power eleva o numero (Uses Math)
  delta := Power(StrTofloat(txtb.Text), 2) - (4 * StrToFloat(txta.Text) * StrToFloat(txtc.Text));
  lblraiz.Caption := FloatToStr(delta);

  if delta <= 0 then
  begin
    lblRaiznegativa.Caption := 'No Existe Raiz real Negativa';
    LblNaocalcula.Caption := 'No  possivel calcular com os valores de A, B, C.';
    lblX1.Caption := 'Null';
    lblX2.Caption := 'Null';
  end else begin

    lblRaiznegativa.Caption := ' ';
    LblNaocalcula.Caption := ' ';
    //calcula os calores de x1 e x2, (SQRT = raiz quadrada)
    x1 := (-StrTofloat(txtb.Text) + (Sqrt(delta))) / (2 * StrTofloat(txta.Text));
    x2 := (-StrTofloat(txtb.Text) - (Sqrt(delta))) / (2 * StrTofloat(txta.Text));

    lblX1.Caption := FloatToStr(x1);
    lblX2.Caption := FloatToStr(x2);

  end;
end;

procedure TfrmBhaskara.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

end.

