unit UntFibonacci;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmFibonacci = class(TForm)
    pnFibonacci: TPanel;
    Label8: TLabel;
    Label10: TLabel;
    txtFibonacci: TEdit;
    BtnFibonacci: TButton;
    pnResult: TPanel;
    Label5: TLabel;
    procedure BtnFibonacciClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmFibonacci: TfrmFibonacci;

implementation

{$R *.dfm}

function Fib(N: longint): longint;
{ Fibonacci por recursao (Muito Lento)}
begin
  if N <= 1 then
    Fib := N
  else
    Fib := Fib(N - 1) + Fib(N - 2);
end;


procedure TfrmFibonacci.BtnFibonacciClick(Sender: TObject);
var I: integer;
begin
  for I := 0 to StrToInt(txtFibonacci.Text) do
    pnResult.Caption := 'Fibonacci de ' + (IntToStr(I) + '  ' + IntToStr(Fib(I)));

  txtFibonacci.SetFocus;
end;

procedure TfrmFibonacci.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

end.

