unit UntTabuada;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, StdCtrls;

type
  TFrmTabuada = class(TForm)
    Label1: TLabel;
    txtTabuada: TEdit;
    btnTabuada: TButton;
    GBTabuada: TGroupBox;
    Panel1: TPanel;
    gridm1: TStringGrid;
    gridm2: TStringGrid;
    gridm3: TStringGrid;
    Panel2: TPanel;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    Grida1: TStringGrid;
    Grida2: TStringGrid;
    Grida3: TStringGrid;
    Panel4: TPanel;
    GroupBox2: TGroupBox;
    Panel5: TPanel;
    Grids1: TStringGrid;
    Grids2: TStringGrid;
    Grids3: TStringGrid;
    Panel6: TPanel;
    GroupBox3: TGroupBox;
    Panel7: TPanel;
    Gridd1: TStringGrid;
    Gridd2: TStringGrid;
    Gridd3: TStringGrid;
    Panel8: TPanel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure btnTabuadaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmTabuada: TFrmTabuada;

implementation

{$R *.dfm}
function Arredondar(Valor: Double; Dec: Integer): Double;
var
  Valor1, Numero1, Numero2, Numero3: Double;
begin
  Valor1 := Exp(Ln(10) * (Dec + 1));
  Numero1 := Int(Valor * Valor1);
  Numero2 := (Numero1 / 10);
  Numero3 := Round(Numero2);
  Result := (Numero3 / (Exp(Ln(10) * Dec)));
end;

procedure TFrmTabuada.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //habilita o enter como tab
  if key = #13 then
  begin
    key := #0;
    perform(WM_NEXTDLGCTL, 0, 0);
  end;

  if Key = #27 then
    close;
end;

procedure TFrmTabuada.btnTabuadaClick(Sender: TObject);
var
  i, x, m, a, s: integer;
  d:real;
begin
  i := 0;
  if txtTabuada.Text = '' then
  begin
    ShowMessage('O valor no pode ser nulo');
  end else begin
    for i := 0 to 11 do begin
      gridm1.Cells[0, i] := IntToStr(i);
      grida1.Cells[0, i] := IntToStr(i);
      grids1.Cells[0, i] := IntToStr(i);
      gridd1.Cells[0, i] := IntToStr(i);
    end;

    for i := 0 to 11 do begin
      gridm2.Cells[0, i] := ' ' + txtTabuada.Text + ' =';
      grida2.Cells[0, i] := ' ' + txtTabuada.Text + ' =';
      grids2.Cells[0, i] := ' ' + txtTabuada.Text + ' =';
      gridd2.Cells[0, i] := ' ' + txtTabuada.Text + ' =';
    end;

    x := StrToInt(txtTabuada.Text);
    for i := 0 to 11 do begin
      m := i * x;
      a := i + x;
      s := i - x;
      d := Arredondar((i / x),4);
      
      gridm3.Cells[0, i] := ' ' + IntToStr(m);
      grida3.Cells[0, i] := ' ' + IntToStr(a);
      grids3.Cells[0, i] := ' ' + IntToStr(s);
      gridd3.Cells[0, i] := ' ' + FloatToStr(d);

    end;
  end;
  txtTabuada.SetFocus;
end;

end.

